import Request from "../Request.js";

export default function Trans() {
  const sp = `
    <button class="option" todo="addRoute">新增車次/停靠站</button>
    <button class="option" todo="information">查看車次</button><br> 
    <div id="content"></div>
`;
  $("#root").html(sp);
  $(".option").click(function (e) {
    const todo = $(this).attr("todo");
    switch (todo) {
      case "information":
        information();
        break;
      case "addRoute":
        addRoute();
        break;
      default:
        break;
    }
  });
  function addRoute() {
    const sp = `
        <h1>新增停靠站</h1><br>
        <select name="" id="stopCode">
          <option value=""></option>
        </select><br>
        <h2>到達時間 若為底站則留空</h1><br>
        <input type="time" id="arrivalTime"><br>
        <h2>出發時間 若為起站則留空</h1><br>
        <input type="time" id="deptTime"><br>
        <h2>起站至今為止的價錢 若為起站則填0</h1><br>
        <input type="text" id="price" valu="0"><br>
        <button id="addRoute">新增</button>

        <div id="content"></div>
    `;
    $("#root").html(sp);
    Request()
      .post("index.php?action=getStation")
      .then(function (data) {
        let response = data["data"];
        response.result.forEach(function (item) {
          let h = `<option value="${item.code}">${item.StationName}</option>`;
          $("#stopCode").append(h);
        });
        $("#addRoute").click(function (e) {
          let ArrivalTime =
            $("#arrivalTime").val() == "" ? "NULL" : $("#arrivalTime").val();
          let DeptTime =
            $("#deptTime").val() == "" ? "NULL" : $("#deptTime").val();
          Request()
            .post(
              "/index.php?action=newRoute",
              Qs.stringify({
                StationCode: $("#stopCode").val(),
                ArrivalTime: ArrivalTime,
                DeptTime: DeptTime,
                Price: $("#price").val(),
              })
            )
            .then(function (resp) {
              if (resp["data"].status == 200) {
                alert("新增成功");
                Request()
                  .post(
                    "index.php?action=getRoute",
                    Qs.stringify({
                      max: "yes",
                    })
                  )
                  .then(function (data) {
                    let response = data["data"];
                    response.result.forEach(function (item) {
                      newTrans(item.id);
                    });
                  });
              } else {
                alert("新增失敗");
              }
            });
        });
      });
  }

  function newTrans(routeID) {
    const sp = `
    <h1>新增車次</h1>
        <input placeholder="車次" id="Trans">
        <input placeholder="RouteID" id="RouteID" value="${routeID}">
        <button id="addTrans">新增</button>
        <div id="content"></div>
    `;
    $("#root").html(sp);
    $("#addTrans").click(function (e) {
      Request()
        .post(
          "index.php?action=newTrain",
          Qs.stringify({
            TransID: $("#Trans").val(),
            RouteID: $("#RouteID").val(),
          })
        )
        .then(function (data) {
          information();
        })
        .catch(function (err) {});
    });
  }

  function information() {
    Request()
      .post("/index.php?action=getTrain")
      .then(function (data) {
        let response = data["data"];
        const sp = `
      <div class="container">
        <h1>車次資訊</h1>
        <table class="table table-striped" id="contenti">
            <tr>
                <th>車次</th>
                <th>動作</th>
            </tr>
        </table>
      </div>`;
        $("#root").html(sp);
        response.result.forEach(function (item) {
          let h = `
              <tr id="${item.TransID}" >
                  <td>${item.TransID}</td>
                  <td>
                  <button class="option" todo="viewRoute" value="${item.TransID}">查看停靠站</button>
                  <button class="option" todo="addSeat" value="${item.TransID}">新增座位</button>
                  <button class="option" todo="viewSeat" value="${item.TransID}">查看座位</button>
                  <button class="option" todo="removeTrans" value="${item.TransID}">刪除車次</button>
                  </td>
              </tr>
            `;
          $("#contenti").append(h);
        });

        $(".option").click(function (e) {
          const todo = $(this).attr("todo");

          if (todo == "viewRoute") {
            viewRoute($(this).attr("value"));
          } else if (todo == "addSeat") {
            addSeat($(this).attr("value"));
          } else if (todo == "viewSeat") {
            viewSeat($(this).attr("value"));
          } else if (todo == "removeTrans") {
            removeTrans($(this).attr("value"));
            console.log("clicked" + todo);
          }
        });

        function removeTrans(e) {
          let sure = confirm("確定要刪除該車次嗎?");
          if (sure) {
            Request()
              .post(
                "/index.php?action=removeTrain",
                Qs.stringify({ TransID: e })
              )
              .then(function (resp) {
                if (resp["data"].status == 200) {
                  alert("刪除成功");
                  information();
                } else {
                  alert("刪除失敗");
                }
              });
          }
        }

        $(".clickTicket>td").click(function (e) {});
      });

    function viewRoute(e) {
      let sp = `
        <div class="container">
        <h1>車次路線</h1>
        <table class="table table-striped" id="contenti">
            <tr>
                <th>車次</th>
                <th>車站</th>
                <th>車站代碼</th>
                <th>抵達時間</th>
                <th>出發時間</th>
                <th>價格</th>
                <th>動作</th>
            </tr>
        </table>
      </div>`;
      $("#root").html(sp);
      let id = e;
      Request()
        .post(
          "/index.php?action=getRouteByTrain",
          Qs.stringify({ TransID: id })
        )
        .then(function (date) {
          let response = date["data"];
          response.result.forEach(function (item) {
            let h = `
            <tr>
                <td>${item.TransID}</td>
                <td>${item.StationName}</td>
                <td>${item.code}</td>
                <td>${item.arrivalTime}</td>
                <td>${item.deptTime}</td>
                <td>${item.Price}</td>
                <td><button id="delRoute" value="${item.RouteID}">刪除</button></td>
            </tr>
            `;
            $("#contenti").append(h);
          });
          $("#delRoute").click(function (e) {
            let sure = confirm("確定要刪除該停靠站嗎?");
            if (sure) {
              Request()
                .post(
                  "/index.php?action=removeRoute",
                  Qs.stringify({ id: $(this).attr("value") })
                )
                .then(function (resp) {
                  if (resp["data"].status == 200) {
                    alert("刪除成功");
                    information();
                  } else {
                    alert("刪除失敗");
                  }
                });
            }
          })
        });
    }
    function addSeat(e) {
      let sp = `
      <div class="container">
      <h1>新增座位</h1>
      <input placeholder="車次" id="TransID" value="${e}">
      <select id="Type">
        <option value="0">普通座位</option>
        <option value="1">商務座位</option>
      </select>
      <input placeholder="數量" id="Quantity" value="">
      <button id="addSeat">新增</button>
      `;
      $("#root").html(sp);
      $("#addSeat").click(function (e) {
        Request()
          .post(
            "/index.php?action=newSeat",
            Qs.stringify({
              TransID: $("#TransID").val(),
              Type: $("#Type").val(),
              Quantity: $("#Quantity").val(),
            })
          )
          .then(function (resp) {
            if (resp["data"].status == 200) {
              alert("新增成功");
              information();
            } else {
              alert("新增失敗");
            }
          });
      });
    }
    function viewSeat(e) {
      // getSeatbyTrains
      let sp = `
      <div class="container">
      <h1>座位</h1>
      <table class="table table-striped" id="contenti">
          <tr>
              <th>車次</th>
              <th>座位類別</th>
              <th>數量</th>
          </tr>
      </table>
      </div>`;
      $("#root").html(sp);
      Request().post("/index.php?action=getSeatbyTrains", Qs.stringify({ TransID: e })).then(function (date) {
        let response = date["data"];
        response.result.forEach(function (item) {
          let h = `
          <tr>
              <td><input type="text" class="myForm TransID" value="${item.TransID}" data-source="${item.id}"></td>
              <td><input type="text" class="myForm Type" value="${item.Type}" data-source="${item.id}"></td>
              <td><input type="text" class="myForm Quantity" value="${item.Quantity}" data-source="${item.id}"></td>
          </tr>
          `;
          $("#contenti").append(h);
        });
        $(".myForm").change(function (e) {
          let id = $(this).attr("data-source");
          let TransID = $(`input[data-source="${id}"].TransID`).val();
          let Type = $(`input[data-source="${id}"].Type`).val();
          let Quantity = $(`input[data-source="${id}"].Quantity`).val();

          Request().post("/index.php?action=updateSeat",Qs.stringify({
            id: id,
            TransID: TransID,
            Type: Type,
            Quantity: Quantity

          })).then(function (resp) {
            
          });
        });

      });
    }
  }
}
